package com.alvin.util;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;

public class FileReader {
    private String nextLine;
    private BufferedReader bufferedReader;

    public FileReader(String filePath) throws IOException {
        this(filePath, StandardCharsets.UTF_8.name());
    }

    public FileReader(String filePath, String encode) throws IOException {
        this.bufferedReader = new BufferedReader(new InputStreamReader(new FileInputStream(filePath), encode));
        this.nextLine = this.bufferedReader.readLine();
    }

    public boolean hasNext() throws IOException {
        if (nextLine == null) {
            close();
        }
        return nextLine != null;
    }

    public String next() throws IOException {
        String nowLine = nextLine;
        nextLine = this.bufferedReader.readLine();
        return nowLine;
    }

    public void close() throws IOException {
        this.bufferedReader.close();
    }

    public static void main(String[] args) throws IOException {
        FileReader fileReader = new FileReader("pom.xml");
        while (fileReader.hasNext()) {
            System.out.println(fileReader.next());
        }
    }
}
