package com.alvin.util;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 字符串工具类
 *
 * @author mlamp
 * @date 2022/05/21
 */
public class StringUtil {
    /**
     * 是否为空白字符串，比较常用
     *
     * @param str 年代
     * @return {@link Boolean}
     */
    public static boolean isBlank(String str) {
        int strLen;
        if (str == null || (strLen = str.length()) == 0) {
            return true;
        }
        for (int i = 0; i < strLen; i++) {
            if ((Character.isWhitespace(str.charAt(i)) == false)) {
                return false;
            }
        }
        return true;
    }

    public static Boolean isEmpty(String s) {
        if (s != null && s.length() > 0) {
            return false;
        }
        return true;
    }

    public static Boolean isNotBlank(String s) {
        return !isBlank(s);
    }

    public static Boolean isNotEmpty(String s) {
        return !isEmpty(s);
    }

    private static Pattern pattern = Pattern.compile("-?[0-9]+\\.?[0-9]*");
    public static boolean isNumber(String str) {
        // 通过Matcher进行字符串匹配
        Matcher m = pattern.matcher(str);
        // 如果正则匹配通过 m.matches() 方法返回 true ，反之 false
        return m.matches();
    }
    public static void main(String[] args) {
        System.out.println(isBlank(null));
        System.out.println(isBlank("           "));
        System.out.println(isEmpty("           "));
    }
}
