package com.alvin.service.impl;

import com.alvin.dao.DbKafkaDao;
import com.alvin.entity.DbKafka;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.List;

@SpringBootTest
@RunWith(SpringRunner.class)
public class DbKafkaServiceImplTest {
    @Autowired
    private DbKafkaDao dbKafkaDao;

    @Test
    public void contextLoads() {
        //List<DbKafka> dbKafkas = dbKafkaDao.selectList(null);
        LambdaQueryWrapper<DbKafka> wrapper = new QueryWrapper<DbKafka>().lambda()
                .eq(DbKafka::getName, "hi");

        Page<DbKafka> dbKafkaPage = dbKafkaDao.selectPage(new Page<>(1, 3), null);
        System.out.println(dbKafkaPage);
    }

    @Test
    public void insert() {
        DbKafka dbKafka = new DbKafka();
        dbKafka.setName("testtest");
        dbKafka.setJsonStr("hhh");
        dbKafkaDao.insert(dbKafka);
        System.out.println(dbKafka);
    }

    @Test
    public void update() {
        DbKafka dbKafka = new DbKafka();
        dbKafka.setId(28);
        dbKafka.setName("hello");  // 不能是 null
        dbKafkaDao.updateById(dbKafka);
        System.out.println(dbKafkaDao.selectById(28));
    }

    @Test
    public void delete() {
        dbKafkaDao.deleteById(28);
    }
}
