import com.alibaba.fastjson.JSON;

import java.math.BigDecimal;
import java.util.*;

public class CatBoostTest {
    public static void testCatBoostClassifier(){
        CatBoostClassifier clf = new CatBoostClassifier("/Users/alvin/Downloads/catboost.cbm");
        
        Map<String,Double> num_features = new HashMap<String,Double>();
        Map<String,String> cat_features = new HashMap<String,String>();
        
        //num_features.put("fnlwgt",236379.0);
        //num_features.put("education-num",11.0);
        Map<String, BigDecimal> hashMap = JSON.parseObject("{\n" +
                "  \"income_tax_12m_chu_income_duty_amount_12m\": 0.5,\n" +
                "  \"registcapi_chu_reccap\": 1.0,\n" +
                "  \"vat_sales_huanbi_1y\": 0.2316023872825141,\n" +
                "  \"late_fee_24m\": 0.0,\n" +
                "  \"drs_nodebtscore\": 16.0,\n" +
                "  \"vat_duty_amount_12m\": 11239.52,\n" +
                "  \"stockpercent_jicha\": 2.0,\n" +
                "  \"income_duty_amount_24m\": 7953.72,\n" +
                "  \"cv_vat_sales_12m\": 1.7568520608821654,\n" +
                "  \"vat_sales_huanbi_6m\": -0.146063232514475,\n" +
                "  \"slope_vat_sales_12m\": -0.02365417557711674,\n" +
                "  \"fraud18\": 43.0,\n" +
                "  \"income_tax_12m\": 0.0,\n" +
                "  \"stockpercent\": 49.0,\n" +
                "  \"month_late_fee_24m\": 0.0,\n" +
                "  \"cn_zeroincome_24m\": 8.0,\n" +
                "  \"growth_index\": 0.0,\n" +
                "  \"vat_duty_month_3m\": 3.0,\n" +
                "  \"tl_id_m6_nbank_passorg\": 1.0,\n" +
                "  \"now_amount_tax_arrears_24m\": 0.0,\n" +
                "  \"cn_zerodeclaration_12m\": 0.0,\n" +
                "  \"penalty_count_total\": 2.0,\n" +
                "  \"now_month_tax_arrears_12m\": 0.0\n" +
                "}", HashMap.class);
        for (Map.Entry<String, BigDecimal> entry : hashMap.entrySet()) {
            num_features.put(entry.getKey(), entry.getValue().doubleValue());
        }

        //cat_features.put("workclass","Private");
        //cat_features.put("sex","Male");
        //cat_features.put("relationship","Husband");
        //cat_features.put("race","White");
        //cat_features.put("occupation","Craft-repair");
        //cat_features.put("native-country","United-States");
        //cat_features.put("marital-status","Married-civ-spouse");
        //cat_features.put("hoursperweek","2");
        //cat_features.put("education","Assoc-voc");
        //cat_features.put("capitalloss","0");
        //cat_features.put("capitalgain","0");
        //cat_features.put("age","1");
 
        Double model_prob = clf.predict(num_features,cat_features);
        System.out.println(model_prob);
        System.out.println("sucessed!");
    }

    public static void main(String[] args) {
        testCatBoostClassifier();
    }
 
}