import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.util.UUID;

public class JsonTransformer {

    public static void main(String[] args) {
        String json = "{\n" +
                "    \"relationship\": \"and\",\n" +
                "    \"list\": [\n" +
                "        {\n" +
                "            \"relationship\": \"or\",\n" +
                "            \"list\": [\n" +
                "                {\n" +
                "                    \"key\": \"tag1\",\n" +
                "                    \"op\": \"greater\",\n" +
                "                    \"value\": 0\n" +
                "                },\n" +
                "                {\n" +
                "                    \"key\": \"tag2\",\n" +
                "                    \"op\": \"less\",\n" +
                "                    \"value\": 2\n" +
                "                },\n" +
                "                {\n" +
                "                    \"key\": \"tag5\",\n" +
                "                    \"op\": \"equals\",\n" +
                "                    \"value\": 7\n" +
                "                }\n" +
                "            ]\n" +
                "        },\n" +
                "        {\n" +
                "            \"relationship\": \"and\",\n" +
                "            \"list\": [\n" +
                "                {\n" +
                "                    \"key\": \"tag3\",\n" +
                "                    \"op\": \"equals\",\n" +
                "                    \"value\": 4\n" +
                "                }\n" +
                "            ]\n" +
                "        },\n" +
                "        {\n" +
                "            \"relationship\": \"and\",\n" +
                "            \"list\": [\n" +
                "                {\n" +
                "                    \"key\": \"tag3\",\n" +
                "                    \"op\": \"equals\",\n" +
                "                    \"value\": 4\n" +
                "                },\n" +
                "                {\n" +
                "                    \"relationship\": \"or\",\n" +
                "                    \"list\": [\n" +
                "                        {\n" +
                "                            \"key\": \"tag3\",\n" +
                "                            \"op\": \"equals\",\n" +
                "                            \"value\": 4\n" +
                "                        },\n" +
                "                        {\n" +
                "                            \"key\": \"tag4\",\n" +
                "                            \"op\": \"equals\",\n" +
                "                            \"value\": 5\n" +
                "                        }\n" +
                "                    ]\n" +
                "                }\n" +
                "            ]\n" +
                "        }\n" +
                "    ]\n" +
                "}\n";
        JSONObject oldJson = JSONObject.parseObject(json);
        JSONObject newJson = transformJson(oldJson);
        System.out.println(newJson);
    }

    public static JSONObject transformJson(JSONObject oldJson) {
        JSONObject newJson = new JSONObject();
        JSONArray children = new JSONArray();
        newJson.put("id", UUID.randomUUID().toString());
        newJson.put("conjunction", oldJson.getString("relationship"));
        JSONArray oldList = oldJson.getJSONArray("list");
        for (int i = 0; i < oldList.size(); i++) {
            JSONObject oldChild = oldList.getJSONObject(i);
            if (oldChild.containsKey("relationship")) {
                children.add(transformJson(oldChild));
            } else {
                JSONObject child = new JSONObject();
                child.put("id", UUID.randomUUID().toString());
                child.put("left", createFieldJson(oldChild.getString("key")));
                child.put("op", oldChild.getString("op"));
                child.put("right", oldChild.get("value"));
                children.add(child);
            }
        }
        newJson.put("children", children);
        return newJson;
    }

    public static JSONObject createFieldJson(String field) {
        JSONObject fieldJson = new JSONObject();
        fieldJson.put("type", "field");
        fieldJson.put("field", field);
        return fieldJson;
    }

}
