import javax.el.*;
import java.lang.reflect.Method;
import java.util.HashMap;

public class Main {
    public static boolean exec(HashMap<String, Object> map, String execStr) {
        ExpressionFactory factory = ExpressionFactory.newInstance();
        ELContext context = new HashMapELContext(map);
        ValueExpression expression = factory.createValueExpression(context, execStr, boolean.class);
        return (Boolean) expression.getValue(context);
    }

    public static void main(String[] args) {
        HashMap<String, Object> map = new HashMap<>();
        map.put("name", "小明");
        map.put("age", 9);
        map.put("score", 90);

        String execStr = "(age > 8) && (score > 80L)";
        System.out.println(exec(map, execStr));
    }

    private static class HashMapELContext extends ELContext {
        private final HashMap<String, Object> map;

        public HashMapELContext(HashMap<String, Object> map) {
            this.map = map;
        }

        @Override
        public Object getContext(Class key) {
            if (key == HashMap.class) {
                return map;
            }
            return null;
        }

        @Override
        public ELResolver getELResolver() {
            return new MapELResolver();
        }

        @Override
        public FunctionMapper getFunctionMapper() {
            return new FunctionMapper() {
                @Override
                public Method resolveFunction(String prefix, String localName) {
                    return null;
                }
            };
        }

        @Override
        public VariableMapper getVariableMapper() {
            return null;
        }
    }
}
